package com.fufan.mtsaas.modules.base.company.dao;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.fufan.mtsaas.modules.base.company.model.TCompanyPurchase;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 企业采购使用信息表(TCompanyPurchase)表数据库访问层
 *
 * @author Liby
 * @since 2022-06-06 10:24:20
 */
@Repository
public interface TCompanyPurchaseDao  extends BaseMapper<TCompanyPurchase> {

    /**
     * 通过时间顺序查询单条数据
     * @return 实例对象
     */
    TCompanyPurchase queryByOrder(String companyId);
    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    TCompanyPurchase queryById(Long id);

    /**
     * 查询指定行数据
     *
     * @param tCompanyPurchase 查询条件
     * @return 对象列表
     */
    List<TCompanyPurchase> queryAllByLimit(TCompanyPurchase tCompanyPurchase);

    /**
     * 统计总行数
     *
     * @param tCompanyPurchase 查询条件
     * @return 总行数
     */
    long count(TCompanyPurchase tCompanyPurchase);

    /**
     * 新增数据
     *
     * @param tCompanyPurchase 实例对象
     * @return 影响行数
     */
    Integer insert(TCompanyPurchase tCompanyPurchase);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<TCompanyPurchase> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<TCompanyPurchase> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<TCompanyPurchase> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<TCompanyPurchase> entities);

    /**
     * 修改数据
     *
     * @param tCompanyPurchase 实例对象
     * @return 影响行数
     */
    int update(TCompanyPurchase tCompanyPurchase);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Long id);
    /**
     * 通过公司Id删除数据
     *
     * @return 影响行数
     */
    int deleteByCompanyId(Long companyId);

    int updatePurchaseStatusOpen(String date);
    int updatePurchaseStatusClose(String date);
}

